From f184ca5e241d005bc9aa47a0075056303ef584c4 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 27 2017 16:25:38 +0000
Subject: [PATCH 892/1001] Add unit tests


---

diff --git a/hubs/tests/utils/test_pkgdb.py b/hubs/tests/utils/test_pkgdb.py
new file mode 100644
index 0000000..36f4905
--- /dev/null
+++ b/hubs/tests/utils/test_pkgdb.py
@@ -0,0 +1,50 @@
+from __future__ import unicode_literals
+
+import dogpile
+import dogpile.cache
+from mock import Mock, patch
+
+from hubs.tests import APPTest
+from hubs.utils.cache import cache
+from hubs.utils.pkgdb import get_owned_packages
+
+
+class PkgdbUtilsTest(APPTest):
+
+    def setUp(self):
+        super(PkgdbUtilsTest, self).setUp()
+        # Use a memory backend, not the default null backend, or we can't test
+        # the caching feature.
+        cache.configure(backend='dogpile.cache.memory',
+                        replace_existing_backend=True)
+        cache.delete("owned_packages:abompard")
+
+    def _is_cached(self):
+        result = cache.get("owned_packages:abompard", ignore_expiration=True)
+        return not isinstance(result, dogpile.cache.api.NoValue)
+
+    def test_get_owned_packages(self):
+        pkgs = get_owned_packages("abompard", use_cache=False)
+        self.assertEqual(len(pkgs), 42)  # not kidding! :-)
+        for pkg in pkgs:
+            self.assertEqual(type(pkg), type(""))
+        self.assertFalse(self._is_cached())
+
+    def test_get_owned_packages_invalid(self):
+        pkgs = get_owned_packages("abompard", use_cache=False)
+        self.assertListEqual(pkgs, [])
+
+    @patch("hubs.utils.pkgdb.requests")
+    def test_get_owned_packages_cache(self, requests):
+        response = Mock()
+        response.json.return_value = {
+            "point of contact": [],
+            "co-maintained": [],
+        }
+        requests.get.return_value = response
+        get_owned_packages("abompard", use_cache=True)
+        self.assertTrue(self._is_cached())
+        self.assertEqual(requests.get.call_count, 1)
+        get_owned_packages("abompard", use_cache=True)
+        self.assertTrue(self._is_cached())
+        self.assertEqual(requests.get.call_count, 1)
diff --git a/hubs/tests/utils/test_views.py b/hubs/tests/utils/test_views.py
new file mode 100644
index 0000000..ca49dac
--- /dev/null
+++ b/hubs/tests/utils/test_views.py
@@ -0,0 +1,131 @@
+from __future__ import unicode_literals
+
+import flask
+
+import hubs.models
+from hubs.app import app
+from hubs.tests import APPTest, FakeAuthorization, auth_set, app_config
+from hubs.utils.views import get_visible_widgets, get_sse_url
+
+
+class ViewUtilsTest(APPTest):
+
+    def setUp(self):
+        super(ViewUtilsTest, self).setUp()
+        self.app_context = app.app_context()
+        self.app_context.__enter__()
+
+    def tearDown(self):
+        self.app_context.__exit__(None, None, None)
+        super(ViewUtilsTest, self).tearDown()
+
+    def test_removed_widget(self):
+        hub = hubs.models.Hub.get("ralph")
+        widget = hubs.models.Widget(
+            hub=hub, plugin="does-not-exist",
+            left=True, index=-1, _config="{}")
+        self.session.add(widget)
+        with auth_set(app, FakeAuthorization('ralph')):
+            widgets = get_visible_widgets(hub)
+        self.assertNotIn(
+            "does-not-exist", [w.plugin for w in widgets["left"]])
+        widget.left = False
+        self.assertNotIn(
+            "does-not-exist", [w.plugin for w in widgets["right"]])
+
+    def test_get_visible_widgets(self):
+        hub = hubs.models.Hub.get('ralph')
+        with auth_set(app, None):
+            widgets = get_visible_widgets(hub)
+        self.assertListEqual(
+            [w.plugin for w in widgets["left"]],
+            ["feed"])
+        self.assertListEqual(
+            [w.plugin for w in widgets["right"]],
+            ['contact', 'meetings', 'fedmsgstats', 'workflow.updates2stable',
+             'workflow.pendingacls', 'subscriptions', 'badges', 'pagure_pr',
+             'github_pr', 'bugzilla', 'halp', 'about']
+            )
+
+    def test_get_visible_widgets_preview(self):
+        hub = hubs.models.Hub.by_name('ralph')
+        hub.config.visibility = "preview"
+        meetings = hubs.models.Widget.query.filter_by(
+            hub=hub, plugin="meetings").first()
+        # make sure the test is valid
+        assert meetings.left is False
+        # set the widget to "restricted"
+        meetings.visibility = "restricted"
+        # Restricted widgets in preview hubs aren't displayed to
+        # anonymous users.
+        with auth_set(app, None):
+            widgets = get_visible_widgets(hub)
+        self.assertNotIn(
+            "meetings", [w.plugin for w in widgets["right"]])
+        # But they are displayed to members.
+        with auth_set(app, FakeAuthorization('ralph')):
+            widgets = get_visible_widgets(hub)
+        self.assertIn(
+            "meetings", [w.plugin for w in widgets["right"]])
+
+    def test_get_visible_widgets_private(self):
+        hub = hubs.models.Hub.by_name('ralph')
+        hub.config.visibility = "private"
+        meetings = hubs.models.Widget.query.filter_by(
+            hub=hub, plugin="meetings").first()
+        # make sure the test is valid
+        assert meetings.left is False
+        # Widgets in private hubs aren't displayed to
+        # anonymous users.
+        with auth_set(app, None):
+            widgets = get_visible_widgets(hub)
+        self.assertEqual(widgets["left"], [])
+        self.assertEqual(widgets["right"], [])
+        # But they are displayed to members.
+        with auth_set(app, FakeAuthorization('ralph')):
+            widgets = get_visible_widgets(hub)
+        self.assertNotEqual(len(widgets["left"]), 0)
+        self.assertNotEqual(len(widgets["right"]), 0)
+
+    def test_sse_url(self):
+        with app.test_request_context():
+            self.assertEqual(get_sse_url(""), "http://localhost:8080/sse/")
+
+        with app.test_request_context():
+            self.assertEqual(
+                get_sse_url("hub/ralph"),
+                "http://localhost:8080/sse/hub/ralph")
+
+        with app.test_request_context(base_url='http://hubs.example.com/'):
+            self.assertEqual(
+                get_sse_url("hub/ralph"),
+                "http://hubs.example.com:8080/sse/hub/ralph")
+
+        with app.test_request_context(base_url='http://example.com/hubs'):
+            self.assertEqual(flask.url_for("index"), "/hubs/")  # test validity
+            self.assertEqual(
+                get_sse_url("hub/ralph"),
+                "http://example.com:8080/sse/hub/ralph")
+
+        with app.test_request_context(base_url='http://hubs.example.com/'):
+            with app_config(app, {
+                    "SSE_URL": {"host": "hubs-sse.example.com"}
+                    }):
+                self.assertEqual(
+                    get_sse_url("hub/ralph"),
+                    "http://hubs-sse.example.com/hub/ralph")
+
+        with app.test_request_context(base_url='http://hubs.example.com/'):
+            with app_config(app, {
+                    "SSE_URL": {"host": "hubs-sse.example.com",
+                                "port": 8080}
+                    }):
+                self.assertEqual(
+                    get_sse_url("hub/ralph"),
+                    "http://hubs-sse.example.com:8080/hub/ralph")
+
+        with app.test_request_context(base_url='http://localhost/hubs'):
+            with app_config(app, {"SSE_URL": {"host": "example.com"}}):
+                self.assertEqual(
+                    get_sse_url("hub/ralph"),
+                    "http://example.com/hub/ralph")
